-- Notee-fi build 1820 --
-- done by ZaP

screen.clear();

cBlack = color.new(0, 0, 0);
cWhite = color.new(255, 255, 255);
cLightGrey = color.new(230, 230, 255);
cDarkGrey = color.new(100, 100, 100, 200);
cBlack75 = color.new(0, 0, 0, 192);
cGrey = color.new(127, 127, 127);

img_button = image.load("img/button.png");
img_button_click = image.load("img/click.png");
img_button_long = image.load("img/button_long.png");
img_button_mid = image.load("img/button_mid.png");
img_font = image.load("img/font.png");

lines = {};
wrap = {};
lines[0] = "";
linecount = 0;
hide_kbd = 0;

keyboard = {};
keyboard[0] = "!qwertyuiop?";
keyboard[1] = ":asdfghjkl*+";
keyboard[2] = ".,zxcvbnm;-/";

keyboard[3] = "!QWERTYUIOP?";
keyboard[4] = ":ASDFGHJKL*+";
keyboard[5] = ".,ZXCVBNM;-/";

dofile("custom_keyboard.txt");

local i = 6;
local l = "";

shift = 0;

topmargin = 240 - 128;

cursor = 0;
line = 0;
textsize = 14;
textw = math.floor(textsize * 0.5);

scrollx = 0;
scrolly = 0;

file_dlg = 0;
file_dlg_text = "";

displayed_lines = math.floor(topmargin / textsize)

function cls()

	screen.fillrect(0, 0, 400, 240, cWhite);
	
end;

function GetKey()
	
	local x = 0;
	local y = 0;
	local l = 0;
	local ymargin = 0;
	
	for y = 0, 2 do
		if hide_kbd == 1 then break; end;
	
		l = string.len(keyboard[y]) - 1;
		ymargin = topmargin + y * 32;
	
		for x = 0, l do
			if InRect(x * 32, topmargin + y * 32, 32, 32, touch_x, touch_y) then
				return string.sub(keyboard[y + shift * 3], x + 1, x + 1);
			end;
		end;
	end;
	
	-- special keys
	if InRect(68, 208, 32, 32, touch_x, touch_y) then
		if shift < 2 then
			shift = 1 - shift;
		else
			shift = 0;
		end;
	end;
		
	
	if InRect(100, 208, 160, 32, touch_x, touch_y) then
		return " ";
	end;
	
	if InRect(36, 208, 32, 32, touch_x, touch_y) then
		shift = 2;
	end;
	
	if InRect(324, 208, 64, 32, touch_x, touch_y) then
		return "_BACK";
	end;
	
	if InRect(260, 208, 64, 32, touch_x, touch_y) then
		return string.char(13);
	end;
	
	if InRect(4, 208, 32, 32, touch_x, touch_y) then
		if file_dlg > 0 then
			file_dlg = 0;
		else
			file_dlg = 1;
		end;
	end;
	
	return "";
	
end;

function InRect(rx, ry, rw, rh, x, y)

	return (x >= rx) and (x < rx + rw) and (y >= ry) and (y < ry + rh);

end;

function DrawText(fullscreen)
	
	local flr = math.floor;
	local char = "";
	local x, y = 0, 0;
	local chars_on_width = math.ceil(screen.width() / textw);
	local start_char = flr(math.abs(scrollx) / textw);
	local start_line = flr(math.abs(scrolly) / textsize);
		
	if fullscreen == 1 then
		topmargin = 208;
	else
		topmargin = 240 - 128;
	end;
		
	for y = start_line, flr(topmargin / textsize) + start_line do
		if lines[y] ~= nil and lines[y] ~= "" then
			for x = start_char, chars_on_width + start_char do
				char = string.byte(lines[y], x + 1);
				
				if char ~= nil then
					char = char - 32;
				
					row = flr(char / 18);
					col = (char - row * 18) * textsize;
					row = row * textsize;
				
					dx = x * textw - col + scrollx;
					dy = y * textsize - row + scrolly;
				
					img_font:draw(dx, dy, (dx + col), dy + row, textsize, textsize);
				else
					break;
				end;
				
			end;
		else
			break;
		end;
	end;
	
end;

function DrawKeyboard()

	text.size(18);

	local x = 0;
	local y = 0;
	local l = 0;
	local ymargin = 0;
	local ssub = string.sub;
	
	text.color(cWhite);
	text.size(15);
	
	for y = 0, 2 do
		l = string.len(keyboard[y]) - 1;
		ymargin = topmargin + y * 32;
		
		for x = 0, l do
			dkey = ssub(keyboard[y + shift * 3], x + 1, x + 1);
			if key == dkey then
				img_button_click:draw(x * 32, ymargin);
			else
				img_button:draw(x * 32, ymargin);
			end;
			
			text.draw(x * 32 + 8, ymargin + 4, dkey);
		end;
	end;
	
	-- special keys
	text.size(10);
	
	img_button:draw(64, 208);
	text.draw(69, 220, "a/A");
	
	img_button:draw(32, 208);
	text.draw(37, 220, "šÄ/#", "left", 0, 2);
	
	img_button:draw(0, 208);
	text.draw(5, 220, "*.txt");
	
	img_button_long:draw(96, 208);
	
	text.size(14);
	img_button_mid:draw(320, 208);
	text.draw(336, 215, "[<-]");
	
	img_button_mid:draw(256, 208);
	text.draw(266, 215, "return");
	
	-- scrollbar
	screen.fillrect(384, 0, 16, 240, cGrey);	
	screen.fillrect(385, math.floor(scrolly / textsize) / (linecount + 1) * -240, 14, math.floor(displayed_lines / (linecount + 1) * 240), cBlack);
	
end;


function DrawCursor()

	screen.fillrect(0, line * textsize + scrolly, 400, textsize, cLightGrey);
	screen.fillrect(cursor * textw + scrollx - 2, line * textsize + scrolly, 2, textsize, cBlack);

end;


function SaveLoadDD()
	
	screen.fillrect(0, topmargin - 112, 150, 112, cDarkGrey);
	
	text.color(cWhite);
	text.size(20);
	text.draw(0, topmargin - 103, "Load", "center", 150);
	text.draw(0, topmargin - 66, "Save", "center", 150);
	text.draw(0, topmargin - 28, "Toggle keybd.", "center", 150);
	
	if InRect(0, topmargin - 112, 150, 38, touch_x, touch_y) then
		file_dlg = 2;
		SaveLoadInput();
	elseif InRect(0, topmargin - 64, 150, 37, touch_x, touch_y) then
		file_dlg = 3;
		SaveLoadInput();
	elseif InRect(0, topmargin - 37, 150, 38, touch_x, touch_y) then
		file_dlg = 0;
		hide_kbd = 1 - hide_kbd;
		
		cls();
		DrawCursor();
		DrawText(hide_kbd);
		DrawKeyboard();
	end;
	
end;


function SaveLoadInput()
	
	screen.fillrect(0, 0, 400, topmargin, cDarkGrey);
	screen.fillrect(10, 10, 380, 20, cWhite);
	
	text.color(cBlack);
	text.size(16);
	text.draw(12, 12, file_dlg_text);
	
	local buttontext = "Load file";
	
	if file_dlg == 3 then buttontext = "Save file (overwrite)"; end;
	
	screen.fillrect(10, 45, 380, 50, cBlack);
	
	text.color(cWhite);
	text.size(16);
	text.draw(10, 60, buttontext, "center", 400);
	
end;


function UpdateFileDlg()

	if key ~= "_BACK" then
		if key ~= string.char(13) then
			file_dlg_text = file_dlg_text .. key;
		end;
	else
		if string.len(file_dlg_text) > 0 then
			file_dlg_text = string.sub(file_dlg_text, 1, string.len(file_dlg_text) - 1);
		end;
	end;
	
	if InRect(10, 45, 380, 50, touch_x, touch_y) then
		if file_dlg == 2 then -- load
			LoadFile(file_dlg_text);
			file_dlg = 0;
			file_dlg_text = "";
		end;
		
		if file_dlg == 3 then -- save
			SaveFile(file_dlg_text);
			file_dlg = 0;
			file_dlg_text = "";
		end;
	end;

end;


function ThrowMessage(msg)

	screen.fillrect(20, 20, screen.width() - 40, screen.height() - 40, cBlack75);
	text.color(cWhite);
	text.size(18);
	text.draw(0, screen.height() / 2 - 18, msg, "center", screen.width());
	text.draw(0, screen.height() / 2, "Touch and hold to proceed.", "center", screen.width());
	
	screen.update();
	
	while true do
		if control.read(1) == 1 then
			if ( control.isTouch() == 1 and touch.hold() == 1 ) then
				break;
			end;
		end;
	end;
	
	cls();
	
end;


function SetCursorPos()

	line = math.floor((touch_y - scrolly) / textsize);
	if line >= linecount then line = linecount; end;
	if lines[line] == nil then lines[line] = ""; end;
	
	cursor = math.floor((touch_x - scrollx) / textw);
	if cursor > string.len(lines[line]) then cursor = string.len(lines[line]); end;
	if cursor == string.len(lines[line]) and string.sub(lines[line], string.len(lines[line])) == string.char(13) then
		cursor = cursor - 1;
	end;

end;


function ReadLine(stream)

	local line = "";
	local char = "";
	
	while true do
		
		char = stream:read(1);
		
		-- windows carriage return?
		if char == "\r" then char = stream:read(1);	end;
		if char == "\n" then break; end;
		if char == nil then
			if line == "" then line = nil; end;
			break;
		end;
		
		line = line .. char;
	end;
	
	if line ~= nil then
		return line .. "\n";
	else
		return line;
	end;

end;


function LoadFile(file)

	local i = 0;
	local line_max_len = math.floor(384 / textw);
		
	hfile = io.open(file, "r");
	
	if hfile then
		for i = 0, linecount do
			lines[i] = nil;
		end;
	
		linecount = 0;
	
		-- l = hfile:read("*line");
		l = ReadLine(hfile);
		
		while l ~= nil do
			lines[linecount] = l;
			linecount = linecount + 1;
			-- l = hfile:read("*line");
			l = ReadLine(hfile);
		end;
	
		--[[
		pos = hfile:seek();
		size = hfile:seek("end");
		hfile:seek("set", pos);
		offset = size - pos;
	
		if offset ~= 0 then
	
			l = hfile:read(offset);
			lines[linecount] = l;
			linecount = linecount + 1;
	
		end;
		]]
		--[[ for anyone who is
		interested in the line wrapping code:
		for-loop does not work here because the loop count cannot be
		increased during the execution.
		]]
		while i < linecount do
			if string.len(lines[i]) >= line_max_len then WrapLine(i); end;
			i = i + 1;
		end;
	
		scrollx = 0;
		scrolly = 0;
		cursor = 0;
		
		hfile:close();
	else
		ThrowMessage("File does not exist.");
	end;

end;


function FindCharReverse(s, c)

	for i = string.len(s), 0, -1 do
		if string.sub(s, i, i) == c then return i; end;
	end;

end;


function WrapLine(n)

	local ln = lines[n];
	local i = 0;
	local line_max_len = math.floor(384 / textw);

	for i = linecount + 1, n + 2, -1 do
		lines[i] = lines[i - 1];
	end;

	wrap[n] = true;
	linecount = linecount + 1;
	
	local l, r = 0, 0;  -- left/right part to split
	local cut = 0;		-- split index
	local recent = 0;
	
	for i = 0, string.len(ln) do
		recent = i;
		
		i = string.find(ln, " ", i);
		
		if i == nil then cut = line_max_len - 1; break; end;
		if i * textw >= 384 then cut = recent - 1; break; end;
	end;
	
	l = string.sub(ln, 0, cut);
	r = string.sub(ln, cut + 1);
	
	lines[n] = l;
	lines[n + 1] = r;
	
	line = line + 1;
	
	cursor = string.len(lines[line]);
	
end;


function SaveFile(file)

	local i = 0;
	local stream = io.open(file, "w");
	
	for i = 0, linecount do
		if wrap[i] == true then
			stream:write(lines[i]);
		else
			stream:write(lines[i] .. "\n");
		end;
	end;
	
	stream:close();
	
	ThrowMessage("Document saved as '" .. file .. "'.");

end;

local line_max_len = math.floor(384 / textw);

touch_x, touch_y, oldx, oldy = 0, 0, 0, 0;
key = 0;

cls();
DrawText();
DrawKeyboard();
screen.update();

while true do
	
	if control.read(1) == 1 then
		cls();
	
		if (control.isTouch() == 1) then

			if touch.down() == 1 then
				touch_x, touch_y = touch.pos();
				
				oldx = touch_x;
				oldy = touch_y;
				
				
				if touch_y < topmargin then
					SetCursorPos();
					key = "";
				else
					key = GetKey();
				end;
				
				if file_dlg == 0 then
					
					if string.len(key) == 1 then
						lines[line] = string.sub(lines[line], 0, cursor) .. key .. string.sub(lines[line], cursor + 1);
						cursor = cursor + 1;
						
						if string.len(lines[line]) == line_max_len then WrapLine(line); end;
						
						if key == string.char(13) then
							line = line + 1;
							linecount = linecount + 1;
							if lines[linecount] == nil then lines[linecount] = ""; end;
							
							for i = linecount, line + 1, -1 do
								lines[i] = lines[i - 1];
							end;
							
							lines[line] = string.sub(lines[line - 1], cursor + 1);
							lines[line - 1] = string.sub(lines[line - 1], 0, cursor);
							
							cursor = 0;
						end;
					else
						if key == "_BACK" then
							delete = false;
							
							if line > 0 then
								delete = true;
							else
								if cursor > 0 then delete = true; end;
							end;
						
							if delete then
								if cursor ~= 0 then
									lines[line] = string.sub(lines[line], 0, cursor - 1) .. string.sub(lines[line], cursor + 1);
									cursor = cursor - 1;
								else
									lines[line - 1] = string.sub(lines[line - 1], 0, string.len(lines[line - 1]) - 1) .. lines[line];
								
									for i = line, linecount do
										lines[i] = lines[i + 1];
									end;
									
									cursor = string.len(lines[line - 1]);									
									linecount = linecount - 1;
									line = line - 1;
								end;
							end;
						end;
					end;
				else
					UpdateFileDlg();
				end;
			elseif (touch.move() == 1) and file_dlg <= 1 then
				touch_x, touch_y = touch.pos();
					
				if touch_x >= 384 then
					scrolly = math.floor(touch_y / 240 * linecount) * -textsize;
				else
					if touch_y < topmargin then
						scrolly = scrolly - (oldy - touch_y);
						oldy = touch_y;
					end;
				end;
				
			elseif (touch.click() == 1) then
				key = "";
				DrawKeyboard();

			elseif (touch.up() == 1) then
				if scrollx > 0 then scrollx = 0; end;
				if scrolly > 0 then scrolly = 0; end;
			end;
		end;
		
		DrawCursor();
		DrawText(hide_kbd);
	
		if file_dlg == 1 then -- show save/load option
			SaveLoadDD();
		elseif file_dlg >= 2 then -- load
			SaveLoadInput();
		end;
		
		DrawKeyboard();
		
		if (control.isButton() == 1) and (button.home() == 1) and (button.click() == 1) then 
			break;
		end;
	end;
	
	screen.update();
	
end;